# std::queue< Type, Sequence > Class Template Reference
[Containers, Sequences]

A standard container giving FIFO behavior. More...

`#include <stl_queue.h>`

List of all members.

## Public Member Functions

| queue (const Sequence &c=Sequence())
| Default constructor creates no elements.
bool | empty () const
size_type | size () const
reference | front ()
const_reference | front () const
reference | back ()
const_reference | back () const
void | push (const value_type &x)
| Add data to the end of the queue.
void | pop ()
| Removes first element.

## Protected Attributes

Sequence | c

## Detailed Description

### template<typename Type, typename Sequence>
class std::queue< Type, Sequence >

A standard container giving FIFO behavior.

Meets many of the requirements of a container, but does not define anything to do with iterators. Very few of the other standard container interfaces are defined.

This is not a true container, but an adaptor. It holds another container, and provides a wrapper interface to that container. The wrapper is what enforces strict first-in-first-out queue behavior.

The second template parameter defines the type of the underlying sequence/container. It defaults to std::deque, but it can be any type that supports `front`, `back`, `push_back`, and `pop_front`, such as std::list or an appropriate user-defined type.

Members not found in "normal" containers are `container_type`, which is a typedef for the second Sequence parameter, and `push` and `pop`, which are standard queue/FIFO operations.

Definition at line 106 of file stl_queue.h.

## Constructor & Destructor Documentation

template<typename Type, typename Sequence>
std::queue< Type, Sequence >::queue | ( | const Sequence & | c = `Sequence()` | ) | `[inline, explicit]`

| Default constructor creates no elements. Definition at line 146 of file stl_queue.h. References std::queue< Type, Sequence >::c.

## Member Function Documentation

template<typename Type, typename Sequence>
const_reference std::queue< Type, Sequence >::back | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reference to the data at the last element of the queue. Definition at line 198 of file stl_queue.h. References std::queue< Type, Sequence >::c.

template<typename Type, typename Sequence>
reference std::queue< Type, Sequence >::back | ( |  | ) | `[inline]`

| Returns a read/write reference to the data at the last element of the queue. Definition at line 187 of file stl_queue.h. References std::queue< Type, Sequence >::c.

template<typename Type, typename Sequence>
bool std::queue< Type, Sequence >::empty | ( |  | ) | const`[inline]`

| Returns true if the queue is empty. Definition at line 152 of file stl_queue.h. References std::queue< Type, Sequence >::c.

template<typename Type, typename Sequence>
const_reference std::queue< Type, Sequence >::front | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reference to the data at the first element of the queue. Definition at line 176 of file stl_queue.h. References std::queue< Type, Sequence >::c.

template<typename Type, typename Sequence>
reference std::queue< Type, Sequence >::front | ( |  | ) | `[inline]`

| Returns a read/write reference to the data at the first element of the queue. Definition at line 165 of file stl_queue.h. References std::queue< Type, Sequence >::c.

template<typename Type, typename Sequence>
void std::queue< Type, Sequence >::pop | ( |  | ) | `[inline]`

| Removes first element. This is a typical queue operation. It shrinks the queue by one. The time complexity of the operation depends on the underlying sequence. Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop() is called. Definition at line 229 of file stl_queue.h. References std::queue< Type, Sequence >::c.

template<typename Type, typename Sequence>
void std::queue< Type, Sequence >::push | ( | const value_type & | x | ) | `[inline]`

Add data to the end of the queue.

Parameters:

  | x | Data to be added.

This is a typical queue operation. The function creates an element at the end of the queue and assigns the given data to it. The time complexity of the operation depends on the underlying sequence.

Definition at line 214 of file stl_queue.h.

References std::queue< Type, Sequence >::c, and std::queue< Type, Sequence >::push().

Referenced by std::queue< Type, Sequence >::push().

template<typename Type, typename Sequence>
size_type std::queue< Type, Sequence >::size | ( |  | ) | const`[inline]`

| Returns the number of elements in the queue. Definition at line 157 of file stl_queue.h. References std::queue< Type, Sequence >::c.

## Member Data Documentation

template<typename Type, typename Sequence>
Sequence std::queue< Type, Sequence >::c `[protected]`

'c' is the underlying container. Maintainers wondering why this isn't uglified as per style guidelines should note that this name is specified in the standard, [23.2.3.1]. (Why? Presumably for the same reason that it's protected instead of private: to allow derivation. But none of the other containers allow for derivation. Odd.)

Definition at line 139 of file stl_queue.h.

Referenced by std::queue< Type, Sequence >::back(), std::queue< Type, Sequence >::empty(), std::queue< Type, Sequence >::front(), std::operator==(), std::queue< Type, Sequence >::pop(), std::queue< Type, Sequence >::push(), std::queue< Type, Sequence >::queue(), and std::queue< Type, Sequence >::size().

The documentation for this class was generated from the following file:

- stl_queue.h